<template>
  <div class="app-container">
    <div class="search">
      <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="标签类别" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in labelCategoryList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="标签值" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in tagValueList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" icon="el-icon-plus" @click="handleCreate">新增</el-button>
      <el-button v-if="isRoleEdit" class="danger" icon="el-icon-delete" @click="form_delete">删除</el-button>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="标签类别" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.drivercode }}</span>
          </template>
        </el-table-column>
        <el-table-column label="标签值" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.drivername }}</span>
          </template>
        </el-table-column>
        <el-table-column label="备注" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.drivername }}</span>
          </template>
        </el-table-column>
        <el-table-column label="创建人" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.drivername }}</span>
          </template>
        </el-table-column>
        <el-table-column label="创建时间" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.drivername }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <!-- 编辑 -->
            <el-button class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span class="centerSpan">|</span>
            <el-button class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <el-dialog :title="textMap[dialogStatus]" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="70%">
      <div class="create">
        <el-form ref="temp" :rules="create.rules" :model="create.temp" label-position="right" label-width="155px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="10">
              <el-form-item label="标签类别：" prop="fname">
                <el-input ref="fname" v-model="create.temp.fname" class="filter-item" placeholder="请输入标签类别" type="text" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="10">
              <el-form-item label="备注：" prop="fname">
                <el-input ref="fname" v-model="create.temp.fname" class="filter-item" placeholder="请输入备注" type="text" />
              </el-form-item>
            </el-col>
          </el-row>
          <div style="width: 155px;">
            <el-button style="float: right;margin-bottom: 10px;" icon="el-icon-plus" class="success" @click="handleNewLabelValue">新增标签值</el-button>
          </div>
          <el-table
            :key="create.table.tableKey"
            v-loading="create.table.listLoading"
            element-loading-text="给我一点时间"
            :data="create.table.list"
            border
            fit
            highlight-current-row
            style="width: 100%;"
            :row-style="rowStyle"
            :cell-style="cellStyle"
            class="elTable table-fixed"
          >
            <el-table-column type="selection" align="center" width="50" />
            <el-table-column label="序号" align="center" type="index" width="50px">
              <template slot-scope="scope">
                <span v-if="create.table.pageNum">{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
                <span v-else>1</span>
              </template>
            </el-table-column>
            <el-table-column label="标签值" min-width="110px" align="center">
              <template slot-scope="scope">
                <span v-if="scope.row.NoEdit">{{ scope.row.gpsCode }}</span>
                <el-input v-if="scope.row.Edit" v-model="scope.row.gpsCode" placeholder="标签值" style="width:80%;padding:10px 0;" />
              </template>
            </el-table-column>
            <el-table-column label="标签说明" min-width="110px" align="center">
              <template slot-scope="scope">
                <span v-if="scope.row.NoEdit">{{ scope.row.gpsName }}</span>
                <el-input v-if="scope.row.Edit" v-model="scope.row.gpsName" placeholder="标签说明" style="width:80%;padding:10px 0;" />
              </template>
            </el-table-column>
            <el-table-column label="标签牧场" min-width="110px" align="center">
              <template slot-scope="scope">
                <span v-if="scope.row.NoEdit">{{ scope.row.tname }}</span>
                <el-select v-if="scope.row.Edit" v-model="scope.row.tmrId" @change="(value)=> {handleAssociatedDevicesChange(value,scope.row)}">
                  <el-option v-for="item in labelRanchList" :key="item.id" :label="`名称：${item.tname} 编号：${item.eqcode}类型:${item.tclassname}`" :value="item.id" />
                </el-select>
              </template>
            </el-table-column>
            <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
              <template slot-scope="{row}">
                <!-- 新增 -->
                <el-button v-if="row.isCreate" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="NewLabelcreateData(row)" />
                <span v-if="row.isCreate" class="centerSpan">|</span>
                <el-button v-if="row.isCreate" class="minCancel" icon="el-icon-close" @click="createNewLabelCancel(row)" />
                <!-- 编辑 -->
                <el-button v-if="row.isUpdate && isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleNewLabelUpdate(row)" />
                <span v-if="row.isUpdate && isRoleEdit" class="centerSpan">|</span>
                <el-button v-if="row.isUpdate && isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleNewLabelRowDelete(row)" />
                <!-- 编辑保存 -->
                <el-button v-if="row.isUpdateSave" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="NewLabelupdateData(row)" />
                <span v-if="row.isUpdateSave" class="centerSpan">|</span>
                <el-button v-if="row.isUpdateSave" class="minCancel" icon="el-icon-close" @click="NewLabelupdateCancel(row)" />
              </template>
            </el-table-column>
          </el-table>
        </el-form>
        <div slot="footer" class="dialog-footer" style="bottom: 10px;">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false; ">关闭</el-button>
          <el-button class="save" :disabled="isokDisable" @click="createData()">确认</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
export default {
  name: 'LabelManagement',
  components: { Pagination },
  data() {
    return {
      labelRanchList: [],
      isRoleEdit: [],
      labelCategoryList: [], // 标签类别
      tagValueList: [], // 标签值
      table: {
        getdataListParm: {
          name: 'getDriverList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            enable: '',
            drivername: '',
            drivercode: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },
      dialogStatus: '',
      create: {
        dialogFormVisible: false,
        rules: {},
        temp: {},
        table: {
          getdataListParm: {
            name: 'getDriverList', page: 1, offset: 1, pagecount: parseInt(Cookies.get('pageCount')),
            returntype: 'Map',
            parammaps: { }
          },
          tableKey: 0,
          list: [],
          total: 0,
          listLoading: false
        }
      },
      textMap: {
        create: '新增'
      },
      requestParam: {},
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' }

    }
  },

  created() {
    this.getList()
    this.getButtons()
  },

  methods: {
    getButtons() {
      const Edit = 'Driver'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    handleEnableChange() {
      console.log('点击了是否启用')
    },

    form_search() {
      console.log('点击了查询')
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.drivername = ''
      this.table.getdataListParm.parammaps.enable = ''
      this.table.getdataListParm.parammaps.drivercode = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    handleCreate() {
      console.log('新增')
      // this.create.temp = Object.assign({}, row)
      this.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    handleNewLabelValue() {
      console.log('新增标签值')
      for (let i = 0; i < this.create.table.list.length; i++) {
        if (this.create.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      this.create.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'enable': 1, 'gpsCode': '', 'gpsName': '', 'tmrId': '', 'remark': '' })
    },
    NewLabelcreateData() {
      console.log('点击了新增标签新增保存')
    },
    createData() {
      console.log('点击了新增保存')
    },
    createNewLabelCancel(row) {
      console.log('点击了新增标签新增取消')
      for (let i = 0; i < this.create.table.list.length; i++) {
        if (row.myId === this.create.table.list[i].myId) {
          var listIndex = this.create.table.list.indexOf(this.create.table.list[i])
        }
        if (listIndex > -1) {
          this.create.table.list.splice(listIndex, 1)
          return
        }
      }
    },
    handleNewLabelUpdate(row) {
      for (let i = 0; i < this.create.table.list.length; i++) {
        if (this.create.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 新增false,编辑false,编辑保存true
      row.isCreate = false
      row.isUpdate = false
      row.isUpdateSave = true
    },
    handleNewLabelRowDelete() {
      console.log('点击了新增标签编辑删除')
    },
    NewLabelupdateData() {
      console.log('点击了新增标签编辑保存')
    },
    NewLabelupdateCancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
    },
    handleUpdate(row) {
      console.log('编辑')
    },

    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDriver'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    form_delete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择驾驶员信息', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteDriver', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    }
  }
}
</script>
<style lang="scss" scoped>
  .search{margin-top:10px;}
  
 </style>
